/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
-----------------------------------------------------------------------------
 === 3OS Kernel module descriptor tables class ===
   ਯ ⠡
-----------------------------------------------------------------------------
*/
#include "CONF3OS.H"
#include "ctype.hpp"
#include "heap.hpp"
#include "mem.hpp"
#include "hardware.hpp"
#include "descript.hpp"
#include "dtables.hpp"
#include "kernel.hpp"

extern c_Kernel  *pc_Krnl3OS;
extern THeap     *pc_Heap;     //   㣮 㫥 ꥪ ""

void c_GDT::ReLocate(void){
 register void *ptr = pc_NullDsc;

 m_DwordFlatCopy(ptr, s_VGDTR.dwAddr, SizeGet());
 s_VGDTR.dwAddr = (dword)pc_Krnl3OS->GlobalAddr(ptr);
 s_VGDTR.Write();
}

c_GDT::c_GDT(){
 pc_Heap->SetAlignMode(k_ParaAlign);
  pc_NullDsc = (c_Descriptor*) new char[k_PageSize];
 pc_Heap->SetAlignMode(k_PrevAlign);
 s_VGDTR.Read();
}

c_Descriptor *c_GDT::DAlloc(void){
 register dword dwGDTSize = SizeGet() + sizeof(c_Descriptor);
 if((dwGDTSize % k_PageSize) == sizeof(c_Descriptor)){
  dwGDTSize += (k_PageSize - sizeof(c_Descriptor));
  pc_Heap->SetAlignMode(k_ParaAlign);
   pc_NullDsc = (c_Descriptor*) pc_Heap->ReAlloc(pc_NullDsc, dwGDTSize);
  pc_Heap->SetAlignMode(k_PrevAlign);
  s_VGDTR.dwAddr = (dword) pc_NullDsc;
 }
 s_VGDTR.wLim = (word) dwGDTSize;
 m_Interrupt(Off);
  s_VGDTR.Write();
 #ifdef _IPLANER_CLASS  // 襭  뢠 ᫨ ⮫쪮 ।  IPlaner
   m_Interrupt(On);
 #endif
 return (c_Descriptor*) ((char*)pc_NullDsc + dwGDTSize - sizeof(c_Descriptor));
}


