/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
#ifndef __DESCRIPTOR_TABLES
/*
-----------------------------------------------------------------------------
 == 3OS Kernel definition module ==
  ᠭ ⠭, , ᮢ  ᮢ ਯ ⠡
-----------------------------------------------------------------------------
*/
#define __DESCRIPTOR_TABLES
#include "hardware.hpp"
#include "descript.hpp"
/* 砫쭮  ⠭⭮ । ਯ஢  ⠡ GDT */
enum e_KrnlGDT{
   k_GDNull       = 0x0,    // 㫥 ਯ
   k_GDKrnlCode   = 0x8,    // ਯ  
   k_GDKrnlData   = 0x10,   // ਯ  
   k_GDKrnlStack  = 0x18,   // ਯ ⥪ 
   k_GDKrnlFlat   = 0x20,   // ᪨  4 ਯ
   k_GDKrnlUpCode = 0x28,   // ਯ ६饭    1Mb
   k_GDKrnlUpDate = 0x30,   // ਯ ६饭    1Mb
   k_GDKrnlVideo  = 0x38    // ਯ 
};

/*  㠫쭮 ॣ GDTR */
#pragma pack(1)
struct s_VrGDTR{
   word  wLim;
   dword dwAddr;

   void Set(void *vAddr, word Lim) {dwAddr=(dword)vAddr; wLim=Lim;};
   void Read(void)                 {m_SaveGDTR(this);};
   void Write(void)                {m_LoadGDTR(this);};
};

class c_GDT{
 protected:
  s_VrGDTR         s_VGDTR;
  c_Descriptor *pc_NullDsc;

 public:
  c_GDT();

  void         ReLocate(void);  // ஢ ன GDT  pc_NullDsc
  c_Descriptor *DAlloc(void);   // 뤥  ਯ  GDT

  word  SizeGet(void)                  {return s_VGDTR.wLim;};
  dword AddrGet(void)                  {return s_VGDTR.dwAddr;};
  dword Selector(c_Descriptor *pc_Dsc) {return (dword)pc_Dsc - (dword)pc_NullDsc;};
  c_Descriptor *Dsc_Get(dword dwIndex){
    return (c_Descriptor*) (((dword)pc_NullDsc)+(dwIndex<<3));
  };

  void *operator[] (dword dwIndex){
    return ((c_Descriptor*) (((dword)pc_NullDsc)+dwIndex<<3));
  };
};
#pragma pack(0)

#endif