/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
 3OSKernel module IDT class
*/
#include "CONF3OS.H"
#include "idt.hpp"
#include "mem.hpp"
#include "kernel.hpp"
#include "heap.hpp"
#include "ctype.hpp"
#include "ievents.hpp"

extern c_Kernel  *pc_Krnl3OS;
extern THeap     *pc_Heap;     //   㣮 㫥 ꥪ ""


void c_ISystem::TrapGate_Set(e_DPLevel e_Lvl, c_CodeSpace *pc_Spc, void *Entry)
{
// c_Descriptor::c_Descriptor(e_Lvl,s_ExtType(s_DSysType(k_TrapGate)),k_RAM);
 Attr_Set(e_Lvl,s_ExtType(s_DSysType(k_TrapGate)),k_RAM);
 s_SysObj.bCount     = 0x0;
 s_SysObj.wSelector  = pc_Spc->Selector_Get();
 s_SysObj.wOffset_I  = (word) Entry;
 s_SysObj.wOffset_II = (word) ((dword)Entry >> 16);
}

c_IDT::c_IDT(void)
 : s_VIDTR(pc_Krnl3OS->GlobalAddr(&aIDT),1024)
{
  ((c_ISystem*) &aIDT[0])->TrapGate_Set(k_KLvl, pc_Krnl3OS->pc_SpcCode, &_ICorruption);

  register s_DSysObj  *ISrc, *IDst, *IStop;
  IStop = IDst = ISrc = &aIDT[0x0];
  IStop += 256;

  do
   dwCopy(++IDst, ISrc, sizeof(s_DSysObj)/sizeof(dword));
  while(IDst < IStop);

  s_VIDTR.Write();
}
