/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
#ifndef IDT_CLASS
/*
 3OSKernel definition module IDT class
*/
#define IDT_CLASS
#include "ctype.hpp"
#include "descript.hpp"
#include "spaces.hpp"

#pragma pack(1)
extern void m_LoadIDTR(void *value);

struct s_VrIDTR{
   word  wLim;
   dword dwAddr;

   s_VrIDTR(void *vAddr, word Lim) : dwAddr((dword)vAddr), wLim(Lim) {};
   void Write(void)                {m_LoadIDTR(this);};
};


/* ᫥ ᪫祭   ஢  IDT */
enum e_Exception{
 k_DivisonErr   =  0,
 k_Debug        =  1,
 k_NMI          =  2,
 k_Stop         =  3,
 k_Overload     =  4,
 k_OverBound    =  5,
 k_InvalidOp    =  6,
 k_DenideFPU    =  7,
 k_DoubleErr    =  8,
 k_InvalidTSS   = 10,
 k_SegUnPresent = 11,
 k_StackErr     = 12,
 k_GenProtect   = 13,
 k_PageFault    = 14,
 k_FaultFPU     = 16,
 k_AlignFault   = 17,
 k_MashineCheck = 18,
 k_FaultSSE     = 19
};


class c_ISystem : public c_Descriptor{
 public:
  c_ISystem(e_DPLevel e_Lvl, c_CodeSpace *pc_SCode, e_SysType e_Sys, void *Entry)
   : c_Descriptor(e_Lvl,s_ExtType(s_DSysType(e_Sys)),k_RAM) {};

  void TrapGate_Set(e_DPLevel e_Lvl, c_CodeSpace *pc_SCode, void *Entry);
};

class c_IDT{
 protected:
  s_VrIDTR  s_VIDTR;
  s_DSysObj aIDT[256];

 public:
  c_IDT(void);

  c_ISystem *ISystem_Get(dword dwIndex) { return (c_ISystem*) &aIDT[dwIndex];};

  c_ISystem *operator[] (dword dwIndex) { return ISystem_Get(dwIndex);};
};
#pragma pack(0)

/*  ᮦ Watcom   LIDT[EAX] */
#pragma aux m_LoadIDTR = \
"db 0x0F, 0x01, 0x18"  \
parm [eax]             \
modify[eax];

#endif