/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
  ,  
 interrupts and exception events kernel module
 last update: 20.02.2004 - 18:00
*/
#include "ievents.hpp"
#include "hardware.hpp"
#include "dtables.hpp"
#include "kernel.hpp"

extern c_Kernel *pc_Krnl3OS;

/*       */
void _ITimer(void)
{
#pragma aux _ITimer modify [eax ebx ecx edx esi edi ebp esp];
 push_int();

 SETSEG(DS, k_GDKrnlUpDate);      //  
 SETSEG(ES, k_GDKrnlUpDate);      //  
 SETSEG(FS, k_GDKrnlFlat);        // 4Gb  
 SETSEG(GS, k_GDKrnlVideo);       // -

 pc_Krnl3OS->ICorruption();

 pc_Krnl3OS->pc_ThList->Rotate();
 pc_Krnl3OS->pc_ThList->Imdtly_Get()->Switch();

 pop_int();
 Int_ret();
}

/*   ICorruption */
void __pragma("IntR") _ICorruption(dword ERROR)
{
 SETSEG(DS, k_GDKrnlUpDate);      //  
 SETSEG(ES, k_GDKrnlUpDate);      //  
 SETSEG(FS, k_GDKrnlFlat);        // 4Gb  
 SETSEG(GS, k_GDKrnlVideo);       // -

 pc_Krnl3OS->pc_Out->printf("\n\r#ICorruption! errcode = %d",ERROR);
 m_interrupt_Off();
 m_CPU_Stop();
}

/*   _ILoop */
void __pragma("IntR") _ILoop(dword ERROR)
{
 SETSEG(DS, k_GDKrnlUpDate);      //  
 SETSEG(ES, k_GDKrnlUpDate);      //  
 SETSEG(FS, k_GDKrnlFlat);        // 4Gb  
 SETSEG(GS, k_GDKrnlVideo);       // -

 pc_Krnl3OS->pc_Out->printf("\n\r#ILoop! param = %d",ERROR);
 m_interrupt_Off();
 m_CPU_Stop();
}

/*   _UD */
void __pragma("IntR") _UD(dword p1, dword p2)
{
 SETSEG(DS, k_GDKrnlUpDate);      //  
 SETSEG(ES, k_GDKrnlUpDate);      //  
 SETSEG(FS, k_GDKrnlFlat);        // 4Gb  
 SETSEG(GS, k_GDKrnlVideo);       // -

 pc_Krnl3OS->pc_Out->printf("\n\r#UD! p1 = %d, p2 = %d",p1,p2);
 m_interrupt_Off();
 m_CPU_Stop();
}

/*   #DF */
void __pragma("IntR") _DF(dword ERROR)
{
 SETSEG(DS, k_GDKrnlUpDate);      //  
 SETSEG(ES, k_GDKrnlUpDate);      //  
 SETSEG(FS, k_GDKrnlFlat);        // 4Gb  
 SETSEG(GS, k_GDKrnlVideo);       // -

 pc_Krnl3OS->pc_Out->printf("\n\r#DF! errcode = %d",ERROR);
 m_interrupt_Off();
 m_CPU_Stop();
}

/*   #NP */
void __pragma("IntR") _NP(dword ERROR)
{
 SETSEG(DS, k_GDKrnlUpDate);      //  
 SETSEG(ES, k_GDKrnlUpDate);      //  
 SETSEG(FS, k_GDKrnlFlat);        // 4Gb  
 SETSEG(GS, k_GDKrnlVideo);       // -

 pc_Krnl3OS->pc_Out->printf("\n\r#NP! errcode = %d",ERROR);
 m_interrupt_Off();
 m_CPU_Stop();
}

/*   #GP */
void __pragma("IntR") _GP(dword ERROR)
{
 SETSEG(DS, k_GDKrnlUpDate);      //  
 SETSEG(ES, k_GDKrnlUpDate);      //  
 SETSEG(FS, k_GDKrnlFlat);        // 4Gb  
 SETSEG(GS, k_GDKrnlVideo);       // -

 pc_Krnl3OS->pc_Out->printf("\n\r#GP! errcode = %d",ERROR);
 m_interrupt_Off();
 m_CPU_Stop();
}

/*   #SS */
void __pragma("IntR") _SS(dword ERROR)
{
 SETSEG(DS, k_GDKrnlUpDate);      //  
 SETSEG(ES, k_GDKrnlUpDate);      //  
 SETSEG(FS, k_GDKrnlFlat);        // 4Gb  
 SETSEG(GS, k_GDKrnlVideo);       // -

 pc_Krnl3OS->pc_Out->printf("\n\r#SS! errcode = %d",ERROR);
 m_interrupt_Off();
 m_CPU_Stop();
}

/*   #PF */
void __pragma("IntR") _PF(dword ERROR)
{
 SETSEG(DS, k_GDKrnlUpDate);      //  
 SETSEG(ES, k_GDKrnlUpDate);      //  
 SETSEG(FS, k_GDKrnlFlat);        // 4Gb  
 SETSEG(GS, k_GDKrnlVideo);       // -

 pc_Krnl3OS->pc_Out->printf("\n\r#PF! errcode = %d",ERROR);
 m_interrupt_Off();
 m_CPU_Stop();
}

/*========================================================================
              V8086
		 ESP+0  -    BIOS
		   (VECTOR_ADDR+EIP+CS+EFLAGS+ESP+SS) 
==========================================================================*/
extern void __declspec(naked) _MonitorVM86(void);
void __declspec(naked) _MonitorVM86(void)
{
 _asm
 {
 /*     V8086      VM */
  /* ""   iretf        BIOS */
  push eax
  push 0x20               //    0...4
  pop  ds    
  mov  eax, dword ptr ss:[esp+20+4]	//  SS
  shl  eax, 4						//    
  add  eax, dword ptr ss:[esp+16+4]	//   ESP, EAX =    
  //  ebx       -4
  push ebx                          
   mov  ebx, ss:[esp+12+4+4]
   mov  word ptr ds:[eax-2], bx     //   
   mov  ebx, ss:[esp+8+4+4] 
   mov  word ptr ds:[eax-4], bx     //  CS
   mov  ebx, ss:[esp+4+4+4]
   sub  eax, 6
   mov  word ptr ds:[eax], bx       //  IP
  pop  ebx
  mov  word ptr ss:[esp+20], ax        // ""      
  pop  eax

  xchg eax, ss:[esp+0]              //  EAX  VECTOR_ADDR
  mov eax, ds:[eax]                 // EAX <-   (4  CS:IP)
  mov word ptr ss:[esp+4],  ax      //  IP  (    00    )
  shr eax, 16
  mov word ptr ss:[esp+8], ax      //  CS  (---"---)
  pop eax                            //  EAX     +0
  //=========>>>  ""     <<<===================
  iretd                              
 }
}

/*========================================================================
 / 0x0E (VDM - IRQ6)(PE - #PF)
     V8086
 SS           - 0x10
 ESP          - 0x0C
 EFLAGS       - 0x08
 CS           - 0x04
 EIP          - 0x00
 ========================================================================*/
void __declspec(naked) _Interrupt_0E(void)
{
 _asm
 {
  test dword ptr ss:[esp+0x8],0x00020000   //  VM     EFLAGS  ???
  je   _PF                                  //   #PF
  push 0x38                                 // 0EH * 4
  jmp  _MonitorVM86
  //=================  0xOE =========================
 }
}

/*========================================================================
 / 0x10
     V8086
 SS           - 0x10
 ESP          - 0x0C
 EFLAGS       - 0x08
 CS           - 0x04
 EIP          - 0x00
 ========================================================================*/
void __declspec(naked) _Interrupt_10(void)
{
 _asm
 {
  test dword ptr ss:[esp+0x8],0x00020000   //  VM     EFLAGS  ???
  je   _ICorruption                       
  push 0x40                              // 10H * 4
  jmp  _MonitorVM86
  //=================  0x10 =========================
 }
}

/*========================================================================
 / 0x13
     V8086
 SS           - 0x10
 ESP          - 0x0C
 EFLAGS       - 0x08
 CS           - 0x04
 EIP          - 0x00
 ========================================================================*/
void __declspec(naked) _Interrupt_13(void)
{
 _asm
 {
  test dword ptr ss:[esp+0x8],0x00020000   //  VM     EFLAGS  ???
  je   _ICorruption		           //   0x13,  ICorruption
  push 0x4c                                // 13H * 4
  jmp  _MonitorVM86
  //=================  0x13 =========================
 }
}

/*========================================================================
 / 0x20 (VM = TIMER IRQ0 - INT08) (PE = TIMER)
     V8086
 SS           - 0x10
 ESP          - 0x0C
 EFLAGS       - 0x08
 CS           - 0x04
 EIP          - 0x00
 ========================================================================*/
void __declspec(naked) _Interrupt_20(void)
{
 _asm
 {
  test dword ptr ss:[esp+0x8],0x00020000   //  VM     EFLAGS  ???
  je   _ITimer			           //    PE
  push 0x20                                // (   V8086 IRQ0 - 0x0*4)
  jmp  _MonitorVM86
  //=================  0x20 =========================
 }
}
