/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
#ifndef PIC_CLASS
/*
 3OS Kernel definition module PIC class
*/
#define PIC_CLASS

#define PIC1_Ctrl 0x20    //  ࠢ ஫஬ 1
#define PIC2_Ctrl 0xA0    //  ࠢ ஫஬ 2

#define NMI_Ctrl  0x70    //  ࠢ  NMI
#define CMOS_Ctrl 0x70    //  ࠢ CMOS

// ⠭ 祭  PIC i8259 (஫ 뢠)
#define PIC1_ICW1    0x20
#define PIC2_ICW1    0xA0
#define PIC1_ICW234  0x21
#define PIC2_ICW234  0xA1
#define irq0         0
#define irq1         1
#define irq2         2
#define irq3         3
#define irq4         4
#define irq5         5
#define irq6         6
#define irq7         7

//  ᪠஢ ஫஢
extern i8259_cascade(byte NewVector);
#pragma aux i8259_cascade = \
"out  0x21, al" \
"mov  ah, al" \
"xchg ah, cl" \
"mov  al, 1"  \
"shl  al, cl" \
"xchg ah, cl" \
"out  0xA1, al" \
parm [eax] \
modify [eax];


/*
    7  6  5  4  3  2  1  0
  Ŀ
       ICW3  饣 ஫ pic1
    |    |    |    |        
  irq7  irq5 irq3 irq1
                      
      irq6  irq4  irq2  irq0


     =  뢠 (irq)   祭  ૫

    7  6  5  4  3  2  1  0
  Ŀ
       ICW3   ஫ pic2
    |  |  |  |                
    0  0  0  0  N 

   N -   室 (irq) 饣 ஫  ஬ ᮥ
        ஫. Nmax=16.

  ଠ ਪ ICW4 - ⥫ ᮡ ࠡ⪨ 뢠
  
   7  6  5  4  3  2  1  0
 Ŀ     ICW4  pic2, pic3
      
   |  |  |  |  |      
   0  0  0  1  1      1-8088/8086 \ mPM
                    0-8080/8085 /
                  
                  1- AEOI
                  0- EOI
                
        SFNM    1-騩
 ᯥ樠     0-
        ( BUFF=1)
 ०         
                BUF - ०
                 ਧ樨


 (mPM) ।,    ய஬ ࠡ⠥
  (0 - 8080/8085, 1 - 8086/8088).

 (AEOI),  ࠢ  1,    ०  ⮬᪮
 襭 ࠡ⪨  뢠, ᠭ .  ᫨  
 ࠢ  0,    筮  ᮣ襭:  楤  ࠡ⪨
 ⭮ 뢠  ᠬ 뢠 ᢮   ISR.

 , ᫨  3 (BUF) = 0.  稨
  ஫   BUF =  1 ⠭   1.  稨
 ᪠   ࠢ 1 ⮫쪮  饣 ஫.

 (SFNM)  ⠭  ᯥ樠  ०,
 ਬ塞    ᪠஢     ।  ਮ⮢
 ᮢ  ࠧ ஫஢ (Special Fully Nested Mode).

*/


class c_PIC{
  private:
  public:
   c_PIC(dword BaseVector){  //  PIC
    outp(0x11, PIC1_ICW1);     // \  ଠ  ICW     ICW1
    outp(0x11, PIC2_ICW1);     // / ஫஢ [ICW1,ICW4 ]
    outp(BaseVector, PIC1_ICW234);       // \   -    PIC1
    outp(BaseVector+0x08, PIC2_ICW234);  // /   -    PIC2
    i8259_cascade(irq2);      // ᪠㥬 ஫   irq2 PIC1  ICW3
    outp(0x1, 0x21);          // \   ஫ PIC1, PIC2  ० x8086
    outp(0x1, 0xA1);          // /  ICW4
    outp(0x0, 0x21);          //  蠥 뢠  ஢
    outp(0x0, 0xA1);          //  irq0...irq7 PIC1, irq8...irq15 PIC2    OCW1
   };

   void ResetIRS(void) {outp(0x20,0x20);};
};

#endif