/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
 === 3OS Kernel module class spaces ===
     
*/
#include "CONF3OS.H"
#include "spaces.hpp"
#include "descript.hpp"
#include "kernel.hpp"
#include "heap.hpp"

extern c_Kernel *pc_Krnl3OS;

/*       */
c_Space::c_Space(void *vMem, dword nSize, e_DPLevel e_Lvl, e_SpcType e_SpType)
: c_DSpace(vMem, s_DSpcLimit(nSize), s_ExtType(s_SpcType(e_SpType)), e_Lvl){
}

/*        */
c_Space::c_Space(dword nSize, e_DPLevel e_Lvl, e_SpcType e_SpType)
: c_DSpace(pc_Krnl3OS->GlobalAddr(new char[nSize]), s_DSpcLimit(nSize), s_ExtType(s_SpcType(e_SpType)), e_Lvl){
}


/*   */
c_Context::c_Context(e_DPLevel e_Lvl, dword dwContext)
 : wCtx((word)dwContext)
{
  ps_TSS = (s_STDTSS*) new char[dwContext];
  *((char*)((dword) ps_TSS + dwContext)) = (char) 0xFF;

  pc_DSpace = new c_DSpace(
   pc_Krnl3OS->GlobalAddr(ps_TSS),         // &s_TSS
   s_DSpcLimit(dwContext, 0x0),            // sizeof(s_STDTSS)
   s_DSysType(k_FreeTSS),
   e_Lvl
  );
  s_Switch.bOpcode = 0xEA;
  s_Switch.bRetOp  = 0xC3;
  s_Switch.wSelector = pc_DSpace->Selector_Get();
}

/*   */
void c_Context::Clear(void){
 register dword *ptr = (dword*) ps_TSS,                   //(dword*) &s_TSS
                *end = ptr + wCtx/4;                      // sizeof(s_TSS)
 if(wCtx > k_CtxCommon) end--;            //   IO  INT  ( 1  = 0xFF)
 do *ptr = 0x0; while(++ptr < end);
}




