/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
 16 ࠧ來 "⮢  30S"
*/
#define __CODE16

#include "start16.hpp"
#include "hardware.hpp"
#include "macro.h"
#include "descript.hpp"
#include "keyboard.hpp"
//#include "vesainfo.hpp"

extern s_DVector GDT[8];
extern byte A20_Setup(void);
extern byte A20_PS_Enable(void); 

s_VrGDTR s_VGDTR = {1, 1}; // 樠 
dword VBEbuff[64]= {1};
                    
char text[16] = "3OS>  Real mode";
char vesaok[16] = "3OS>  VESA     ";
char zA20_Error[8]  = "A20 BAD"; 

#pragma pack(16);           // ⠭ ࠢ  ࠣ (=16 )
/*  GDT ࠭ ⮢  ᥣ DATA   ⠭ */
s_DVector GDT[8] = {
//==>  ન - !!! 易⥫  0  GDT
 {0,0},
//==> ਯ ࠭⢠   {precacl size = 64K}
 m_DATA_DESCRIPTOR(0x0FFFF, 0x0, k_RAM, k_KLvl, k_ERCode, k_1Bt, k_D32),
//==> ਯ ࠭⢠  
 m_DATA_DESCRIPTOR(0xFFFFF, 0x0, k_RAM, k_KLvl, k_RWDataUp, k_4Kb, k_D32),
//==> ਯ ࠭⢠   (⥪) - ।⥫
 m_DATA_DESCRIPTOR(0xA000, 0x100000, k_RAM, k_KLvl, k_RWDataUp, k_1Bt, k_D32),
//==> ਯ ࠭⢠  - ᪮ 4 ᭮ -
 m_DATA_DESCRIPTOR(0xFFFFF, 0x0, k_RAM, k_KLvl, k_RWDataUp, k_4Kb, k_D32),
//==> ਯ ࠭⢠    0x10000
 m_DATA_DESCRIPTOR(0xFFFFF, 0x100000, k_RAM, k_KLvl, k_ERCode, k_4Kb, k_D32),
//==> ਯ ࠭⢠    0x10000
 m_DATA_DESCRIPTOR(0xFFFFF, 0x100000, k_RAM, k_KLvl, k_RWDataUp, k_4Kb, k_D32),
//==> ਯ ࠭⢠    0xb8000
 m_DATA_DESCRIPTOR(0x1000, 0xB8000, k_RAM, k_KLvl, k_RWDataUp, k_1Bt, k_D32)
};
#pragma pack(0)            // ⠭ ।饥 祭 ࠢ



void os_main(word AddrBinPack){
#pragma aux os_main parm [si] modify [ax bx cx dx si di]; //  㦥  
 m_Init(); /* 樠 ᥣ⮢ */
// BinPack = (dword) AddrBinPack;
/* 樠 ਯ஢  (  )  ᮬ */
 register word KernelBA = 0xA000;
 s_VGDTR.Set((void*)((word) &GDT[0] + KernelBA), sizeof(GDT));

 KernelBA += (word) &GDT[8];
 ((s_DSpace*) &GDT[1])->wBase_I  = KernelBA;
 ((s_DSpace*) &GDT[2])->wBase_I  = KernelBA;
 ((s_DSpace*) &GDT[5])->wBase_I  = KernelBA; // 0x10  襬 ᫮ 㦥 ⠢
 ((s_DSpace*) &GDT[6])->wBase_I  = KernelBA; // 0x10  襬 ᫮ 㦥 ⠢

 /* 뢠  0  ࠧ ᥣ ⥪ ⮦ ⠥ */
 word StackLimit = KernelBA - sizeof(GDT) + 1;
  ((s_DSpace*) &GDT[3])->wLimit   = StackLimit;

 m_CLS();
 m_OutText(60, 0, text);

 GetVESAInfo(&VBEbuff);
 if (VBEbuff[0]==VESA_SIGNATURE) m_OutText(60, 15, vesaok);

 if(!A20_Setup()) m_CPU_Stop();

 m_interrupt_AllOff();

 m_LoadGDTR(s_VGDTR);
 m_SetPM();
// m_SetAX(KernelBA);
// m_SetBX(StackLimit-1);
 m_SegFarJmp(KernelBA, StackLimit-1, AddrBinPack); // 室    ᮬ ஢
}

byte Verify_A20(void)
{
 return m_Vfy_A20();
}
void IO_delay()// ⥭⭮ IO
{ 
 m_IO_delay();
}

void KbdReady_Wait(void)
{
 register byte state;
  do{
    IO_delay(); 
    state = m_KbdState_Get();
    if((state&0x1) == 0)
     if((state&0x2)==0) break;
      else continue;
    IO_delay();
    m_KbdData_Get();
  } while(1);
}

byte A20_Enable(void) // 祭 १ 8042 AT ⥪
{
#pragma aux A20_Enable value [al];
 KbdReady_Wait();
 m_KbdState_Set(k_Write);
 KbdReady_Wait();
 m_KbdData_Set(0xDF);
 KbdReady_Wait();
 return Verify_A20();
}

byte A20_PS_Enable(void) // 祭 १ BIOS  ⥪
{
#pragma aux A20_PS_Enable value [al];
// m_A20_PS_Enable();
 return Verify_A20();
}

byte A20_Setup(void)
{
#pragma aux Setup_A20 modify [ax bx cx dx]; //  㦥 
 if(A20_Enable()||A20_PS_Enable()) return true;
 m_OutText(0,1,zA20_Error);
 return false;
}
