/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
//
// 3OS Kernel module loader procedures
//
//  last update: 08-12-2002
//  console operation in real-mode
#include "ctype.hpp"
#define m_OutText(X,Y,TEXT) m_putxy(Y<<8|X,sizeof(TEXT),TEXT)

/*
        AH = 13h
        AL = mode
            bit 0: set in order to move cursor after write
            bit 1: set if string contains alternating characters and attributes
        BL = attribute if AL bit 1 clear
        BH = display page number
        DH,DL = row,column of starting cursor position
        CX = length of string
        ES:BP = pointer to start of string
*/
extern void m_putxy(word xy,word size_text,void* addr_text);
#pragma aux m_putxy = \
"pusha"              \
"mov bp, ax"         \
"mov ax, 0x1300"     \
"mov bx, 0x0012"     \
"int 0x10"           \
"popa"               \
modify [bp bx]       \
parm [dx][cx][ax];

extern void m_CLS(void);
#pragma aux m_CLS = \
"push es"           \
"mov ax, 0xb800"    \    
"mov es, ax"        \    
"xor di, di"        \  
"next:"             \
"stosb"             \
"inc di"            \
"cmp di, 2000"      \
"jle next"          \
"pop es"            \    
modify [ax di];

extern void m_Init(void);
#pragma aux m_Init =\
" MOV AX,CS" \
" MOV DS,AX" \
" MOV ES,AX" \
modify [AX];

extern void m_SetPM();
#pragma aux m_SetPM = \
"  MOV EAX, CR0" \
"  OR  AL, 0x01" \
"  MOV CR0, EAX" \
modify [ax];

extern void m_SegFarJmp(word p1, word p2, word p3);
#pragma aux m_SegFarJmp = \
"xor dx, dx" \
"mov dx, fs" \
"shl edx, 4" \
"movzx ecx, cx" \
"add ecx, edx"  \
0xEA 0x00 0x00 0x08 0x00 \
parm [ax][bx][cx];

const dword VESA_SIGNATURE = 0x41534556;

extern void GetVESAInfo(void *buff);
#pragma aux GetVESAInfo =\
"push es"\
"push ds"\
"pop es"\
"pusha"\
"mov ax, 0x4F00"\
"int 0x10"\
"popa"\
"pop es"\
parm[di];


/* 㠫 ॣ GDTR */
struct s_VrGDTR{
   word  wLim;
   dword dwAddr;
   void Set(void *vAddr, word Lim) {dwAddr=(dword)vAddr; wLim=Lim;};
};

/* ப ࠭樨 ᬥ饭    */
#define m_GlobalAddrGet(vAddr) ((dword) &vAddr)+0x0000A000

/*  㧪 GDTR */
#define m_LoadGDTR(vVGDTR) _asm{ LGDT [vVGDTR]}

/*  㧪 GDTR */
#define m_SaveGDTR(vVGDTR) _asm{ SGDT [vVGDTR]}

extern byte m_Vfy_A20(void);
#pragma aux m_Vfy_A20 =\
" push ds "\
" push es "\
" xor ax,ax        " \
" mov ds,ax        " \
" dec ax           " \
" mov es,ax        " \
" mov ax,word ptr es:[0x10] " \
" not ax           " \
" push word ptr ds:[0] "\
" mov word ptr ds:[0],ax       " \
" mov ax, word ptr ds:[0]       " \
" cmp ax,es:[0x10] " \
" pop word ptr ds:[0]"\
" jz  not_a20"\
" xor ax, ax"\
" inc ax"\
" jmp exit"\
"not_a20:"\
" xor ax, ax"\
"exit:"\
" pop es"\
"pop ds"\
value [al];
