/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
// revised: 09-26-2003 00:01:27

#ifndef  __STREAM
#define  __STREAM
#include "ctype.hpp"
#include "heap.hpp"
#include "mem.hpp"

#pragma pack(1)
struct s_Stream{
 dword Size;
 byte  aContainer;
};

enum e_SeekMode{
 k_FromStart = 0,
 k_FromCurr  = 1,
 k_FromEnd   = 2
};

class c_Stream{
protected:
  void  *vStart;
  char  *vPos;
  dword dwSize;

 public:
  c_Stream(dword Size) : dwSize(Size){
   vStart = new char[dwSize];
   vPos = (char*) vStart;
  };
  c_Stream(s_Stream *ps_Stream);

  dword Seek(int dwOffs, e_SeekMode);
  dword Size(void) {return dwSize;};
  void  *End_Get() {return (void*)(((dword) vStart) + dwSize);};
  bool  EOF(void)  {return (bool)(vPos >= End_Get());};
  bool  BOF(void)  {return (bool)(vPos <= vStart);};
};

class c_ThreadStream : public c_Stream{
 protected:
  struct{
   dword nCodeSec;
   dword nDataSec;
   dword StartSec;
   dword CommonSec;
  } s_header;
 public:
  c_ThreadStream(s_Stream *ps_Stream) : c_Stream(ps_Stream)
  {
   dwCopy(&s_header, vPos, sizeof(s_header)/sizeof(dword));
  };

  dword CntCodeSec(void) {return s_header.nCodeSec;};
  void *Code(dword dwIndex){
    return (void*) (((dword)vStart)+sizeof(s_header)+(dwIndex<<2));
  };
};

#pragma pack(0)
#endif  /* __STREAM */