/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
#ifndef __SYSOUT
/*
 == 3OS Kernel definition module class system out ==
*/
#define __SYSOUT

#include "ctype.hpp"
#include "dlcl\3osdlcl.hpp"

class c_Out;

typedef void* (*fGetAddr)(void);
typedef void (c_Out::*dlcl_puts)(const char *text);
typedef void __cdecl (c_Out::*dlcl_printf)(const char *format, ...);
typedef void (c_Out::*dlcl_gotoxy)(int x, int y);
typedef void (c_Out::*dlcl_cls)(void);

union u_dlcl
{
 union
 {
  dlcl_cls metod;
  fGetAddr addr;
 } cls;  
 union
 {
  dlcl_printf metod;
  fGetAddr addr;
 } printf;
 union
 {
  dlcl_gotoxy metod;
  fGetAddr addr;
 } gotoxy;
 union
 {
  dlcl_puts metod;
  fGetAddr addr;
 } puts;
};

struct s_dlclOUT
{
 void *vPuts;
 void *vPrintf;
 void *vGotoXY;
 void *vCLS;
};

class c_Out
{
  void *vVideoBuffer;   //   ⭮⥫쭮 DS
  word *last_offs;      //  樨 뢮  TOut

 // DLCL ଠ  ⮤
 #ifndef __CLASS_EXPORT
  s_dlclOUT  *_OUT_;
 #endif
 public:
  c_Out(void);
  c_Out(void *vVideo);

  void puts(const char *text);                   // 뢮 ப
  void __cdecl printf(const char *format, ...);  // 뢮 ଠ. ப
  void gotoxy(int x, int y){                     // ⠭  x,y
   last_offs = (word*) (((dword) vVideoBuffer) + (x << 1) + (y*160));
  };
  void cls(void);                                // clear screen & home
};

extern void set_es_word(void *addr, word elm);
#pragma aux set_es_word = \
"mov gs:[edi], ax" \
parm [edi][ax];

#endif