/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
 3OS Kenrenl module class of Thread
*/
#include "threads.hpp"
#include "kernel.hpp"

extern c_Kernel  *pc_Krnl3OS;

c_Thread::c_Thread(e_Qualitet e_Qt, e_DPLevel e_Lvl)
 : c_Context(e_Lvl, k_CtxCommon)
{
 Clear();
}

c_Thread::c_Thread(e_Qualitet e_Qt, e_DPLevel e_Lvl, dword dwContext)
 : c_Context(e_Lvl, dwContext)
{
 Clear();
}

void c_Thread::Shared(c_Thread *pc_targ){
 /*   */
 c_StackSpace *pc_Stack = new c_StackSpace(1024,pc_DSpace->Level_Get());

 register s_STDTSS *ps_rTSS = ps_TSS;
 ps_rTSS->wCS = pc_targ->ps_TSS->wCS;
 ps_rTSS->wSS = pc_Stack->Selector_Get();
 ps_rTSS->dwESP = 1024;
}

void c_Thread::LoadFromStream(c_ThreadStream *pc_ThStream)
{
 register void *addr = pc_Krnl3OS->GlobalAddr(pc_ThStream->Code(1));
 c_CodeSpace *pc_Code = new c_CodeSpace(
  pc_ThStream->Size(),
  pc_DSpace->Level_Get(),
  addr
 );
 c_StackSpace *pc_Stack = new c_StackSpace(1024,pc_DSpace->Level_Get());

 register s_STDTSS *ps_rTSS = ps_TSS;
 ps_rTSS->wCS = pc_Code->Selector_Get();
 ps_rTSS->wSS = pc_Stack->Selector_Get();
 ps_rTSS->dwESP = 1024;
}

c_Item *c_ThList::Add(c_Item *add){
 if(dwCount == 0){
  add->Next = add;
  add->Back = add;
  pc_Imdtly = add;
 }
 else{
  register c_Item *Im = pc_Imdtly, *Im_pre = Im->Back;
  add->Next = Im;
  add->Back = Im_pre;
  Im_pre->Next = add;
  Im->Back = add;
 }

 dwCount++;
 return add;
}


