/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
// revised: 09-26-2003 00:01:27

#ifndef  __THREADS
#define  __THREADS
#include "spaces.hpp"
#include "stream.hpp"

enum e_Qualitet {k_Low, k_Medium, k_High};

class c_Thread : public c_Context{
 protected:
   dword       KvantPerMS;    // - ms   
   dword       nKvants;       // -   
   dword       nMin;          // -  
   e_Qualitet  Qualitet;      //    ,    
   e_Qualitet  ReqQualitet;   //  -

 public:
   c_Thread(e_Qualitet e_Qt, e_DPLevel e_Lvl);
   c_Thread(e_Qualitet e_Qt, e_DPLevel e_Lvl, dword dwContext);
   ~c_Thread(void) {};

   void LoadFromStream(c_ThreadStream *pc_ThStream); //    
   void Shared(c_Thread *pc_targ);         //   target

   void Wait(dword msTime);                //      
   void SendIPC(void *ps_IPCMessage);      //    IPC
   void EventIPC(void *ps_IPCMessage);     //   IPC
protected:
   void SetQualitet(e_Qualitet e_Qt) {ReqQualitet = e_Qt;};

private:
   void Execute(void);                      // 
   void Terminate(void);                    //   
};

class c_Item{
 public:
   c_Thread    *Item;
   c_Item      *Back;
   c_Item      *Next;

   c_Item(c_Thread *item) : Item(item) {};
   ~c_Item() {};
};

class c_ThList{
 protected:
  dword    dwCount;

 public:
  c_Item   *pc_Imdtly;   //   
  c_ThList(void) : pc_Imdtly(NULL), dwCount(0) {};
  ~c_ThList(void) {};

  void       Rotate(void)          {pc_Imdtly = pc_Imdtly->Next;};
  c_Item    *Add(c_Item *add);
  c_Thread  *Imdtly_Get(void)      {return pc_Imdtly->Item;};

  dword Count(void) {return dwCount;};
};
#endif  /* __THREADS */
