/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
 Kernel module v8086 thread 
*/
#include "v8086.hpp"
#include "hardware.hpp"

c_ThreadV86::c_ThreadV86(void)
 : c_Thread(k_High,k_ALvl,k_CtxPentium) 
{
/*     IO */
 ps_TSS->BitMap_Set(k_CtxPentium);

/*     lim = 1024 */
 c_StackSpace *pc_Stack = new c_StackSpace(1024,k_KLvl);
 ps_TSS->s_KrnlStack.wSS   = pc_Stack->Selector_Get();
 ps_TSS->s_KrnlStack.dwESP = 1024;

 VM_Set();
}

void c_ThreadV86::CopyFrom(void* To, void* vMem, dword size)
{
 m_FlatCopy(To, vMem, size);
 SetEIP(((dword)To)&0x0000000f);
 SetCS((word) To>>4);
 SetDS((word) To>>4);
 SetES((word) To>>4);
}
