/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
 Virtual 8086 mode session
   c_ThreadV8086
*/
#ifndef __V8086_THREAD
#define __V8086_THREAD

#include "..\\threads.hpp"
#include "..\\descript.hpp"

enum e_V86Int
{
 k_P6Int   = 0x00000001,
 k_386Int  = 0x00000000
};

class c_ThreadV86 : public c_Thread
{
 public:
  c_ThreadV86(void);

  void CopyFrom(void* vTo, void* vFrom, dword size);

  void IOEnable() 
  {
   register dword *pw_Map=((dword*) ((s_PentiumTSS*) ps_TSS)->aMapIO)-1,
            *stop=(dword*) &(((s_PentiumTSS*) ps_TSS)->bFF);
   while(++pw_Map<=stop) *pw_Map = 0x0;
  };
#ifdef __VME  //    V8086  VME 
  void Switch() 
  {
   m_mask_CR4(k_P6Int);
   c_Context::Switch();
  };
#endif
};

#endif